      subroutine bdfr4w(r4arr,nelem1,nelem2,output,refnam,ident,ierr)

      use dal
      use edetect_io

      implicit none

      integer, intent(IN) :: nelem1, nelem2, ierr      
      real(kind=single), dimension(nelem1,nelem2), intent(IN) :: r4arr
      character(len=*), intent(IN) :: output, refnam, ident

      real(kind=single), dimension(:,:), pointer :: r4arr0

      integer :: ix, iy 
!     integer, dimension(2) :: npix
       
      type(DataSetT) :: set, set0
      Type(ArrayT) :: arr

      npix(1)  = nelem1
      npix(2)  = nelem2

      set = dataset(output, write)
      arr = addArray(set, "PRIMARY", Real32, npix)
      r4arr0 => real32array2data(arr)
      do ix=1,nelem1
        do iy=1,nelem2
          if (r4arr(ix,iy) .lt.1000. .and. r4arr(ix,iy) .gt. 0.) then
            r4arr0(ix-1,iy-1)=r4arr(ix,iy)
          else
            r4arr0(ix-1,iy-1)=0.
          end if
        end do
      end do  
      set0 = dataset(refnam, read)
      call cp_head (set0, set, ident, 2)

      call release(set0)
      call release(arr)
      call release(set)   

      return
      end
